use ExtUtils::MakeMaker;
use Config;
use File::Spec;
use strict;

my $pdlroot = File::Spec->catdir($Config{'installvendorarch'}, "PDL", "Core") ;

my $pdltypemap = File::Spec->catfile($pdlroot, "typemap.pdl") ;

WriteMakefile (
    NAME		=> 'perl2c',
    VERSION_FROM 	=> 'lib/perl2c.pm',
    ($] >= 5.005 ?     ## Add these new keywords supported since 5.005
      (ABSTRACT_FROM 	=> 'lib/perl2c.pm', # retrieve abstract from module
       AUTHOR	=> 'Patrick Dupre <pd520@york.ac.uk>') : ()) ,
    LIB			=> '~/perl_lib',
    INSTALLMAN1DIR	=> 'none',
    INSTALLMAN3DIR	=> 'none',
    INC			=> "-I. -I$pdlroot",
    TYPEMAPS		=> [ $pdltypemap ],
    MYEXTLIB		=> 'mylib/libmylib$(LIB_EXT)',
    ) ;

if  (eval {require ExtUtils::Constant; 1}) {
  # If you edit these definitions to change the constants used by this module,
  # you will need to use the generated const-c.inc and const-xs.inc
  # files to replace their "fallback" counterparts before distributing your
  # changes.
  my @names = (qw()) ;
  ExtUtils::Constant::WriteConstants (
    NAME		=> 'perl2c',
    NAMES		=> \@names,
    DEFAULT_TYPE	=> 'IV',
    C_FILE		=> 'const-c.inc',
    XS_FILE		=> 'const-xs.inc',
    ) ;
  }
else {
  use File::Copy ;
  use File::Spec ;
  foreach my $file ('const-c.inc', 'const-xs.inc') {
    my $fallback = File::Spec ->catfile ('fallback', $file) ;
    copy ($fallback, $file) or die "Can't copy $fallback to $file: $!" ;
    }
  }

sub MY::postamble {
  '
  $(MYEXTLIB): mylib/Makefile
	cd mylib && $(MAKE) $(PASSTHRU)
  ' ;
  }
